#!/usr/bin/python
# -*-coding: utf-8-*-

# Programm 3.2 zur Bestimmung der Bestapproximation x
# zur Behandlung des ueberbestimmten Systems C x = y
# unter Nutzung der im Programm 3.1 (qr_gb.py)  erzeugten 
# Matrix c = (c(ij)) und dem Vektor t(i) (QR-Zerlegung)
# input:  Matrix c, Vektor t als Ergebnis des Programms qr_gb0,
#         Vektor y als rechte Seite
# output: Loesung x, Residuenvektor d
# Aufruf: [x,d] = bestapprqr_gb0(c,t,y);

import numpy as np

import qr_gb0

def bestapprqr_gb0(c, t, y0):
    m = len(c) # length(c(mslice[:], 1))
    p = len(c[0]) # length(c(1, mslice[:]))
    x = np.zeros(p) # list(range(0,p))
    d = np.zeros(m) # list(range(0,m))
    y = np.zeros(m)
    for i in range(m):
        y[i] = y0[i]
# Aufbau der rechten Seite Q^T y
    for l in range(0,p): # mslice[1:p]:
        summe = np.dot(c[l:m,l],y[l:m])
        summe = summe + summe
        y[l:m] = y[l:m] - summe*c[l:m,l]
#   endfor
#   Loesung des Gleichungssystems R x = Q^T y
    for l in range(0,p): # mslice[p:-1:1]:
        i = p-1-l
        summe = y[i]
        d[i] = 0 # d(i).lvalue = 0
        if ((i + 1) <= p):
            for k in range(i+1,p): # mslice[i + 1:p]:
                summe = summe - c[i,k]*x[k]
#           endfor
#       endif
        x[i] = summe/t[i] # x(i).lvalue = summe / t(i)     
#   endfor
    if ((p + 1) <= m):
        d[p:m] = y[p:m]
#   endif      
#   Ruecktransformation des Residuums
    for i in range(0,p): # mslice[p:-1:1]:
        l = p-i-1
        summe = np.dot(c[l:m,l],d[l:m])
        summe = summe + summe
        d[l:m] = d[l:m] - summe*c[l:m,l]
#   endfor
#    x
#    d
    return (x,d)
#   endfunction

