#!/usr/bin/python
# -*-coding: utf-8-*-

import math
import numpy as np

# Programm 2.3 Cholesky-Zerlegung a0 = l l^T einer pos.def.,symm. Matrix 
# input:  Matrix a0
# output: untere Dreiecksmatrix l oder l = -1 falls a0 nicht spd
# Aufruf: l = chol_gb0(a0);

def chol_gb0(a0):
    n = len(a0)
    a = np.zeros((n,n))
    a[:,:] = a0[:,:]
    l = np.zeros((n,n)) # l = [[0 for col in range(col)] for row in range(row)]
    for k in range(0,n):
        if (a[k,k] > 0):
            l[k,k] = math.sqrt(a[k,k])
            for i in range(k+1,n):
                l[i,k] = a[i,k]/l[k,k];
                a[i,k+1:i+1] = a[i,k+1:i+1] - l[i,k]*l[k+1:i+1,k]
#           endfor
        else:
            print('Matrix nicht positiv definit')
            l = -1
            break
#       endif
#   endfor
    return l
# endfunction

def main():
    a = np.array([[8,2,1,1],[2,8,2,1],[1,2,8,2],[1,1,2,8]])
    l = chol_gb0(a)

    r = l.T

    print('Dreiecksmatrix L:')
    print(l)

    print('Probe:')
    print(np.dot(l,r))

if __name__ == '__main__':
    main()

