#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np

# Nutzer-Funktion
# exakter Wert von \int_0^1 4/(x*x+1) dx ist pi
def fkt61(x):
    y = 4/(x*x+1)
    return y
#   endfunction

# Programm 6.1 Simpson-Regel
# zur Berechnung von \int_0^1 fkt61(x) dx
# exakter Wert ist \pi
# input:  Intervallgrenzen a,b, n (2n-1 Stuetzwerte)
# output: Integralwert
# benutztes Programm: fkt61
# Aufruf: [integralwert] = fassregel_gb0(a,b,n);

def fassregel_gb0(a,b,n):
    h=(b-a)/(2*n)
    x = np.linspace(a+h,b-h,2*n-1,endpoint=True) # x_0, x_1,..., x_2n-2
    summe = 0.0
    for k in range(0,n-1):
        k2 = k+k + 1
        k3 = k2+1 
        summe = summe + fkt61(x[k2]) + 2*fkt61(x[k3])
#   endfor
    summe = summe + summe
    integralwert = h*(fkt61(a) + 4*fkt61(x[0]) + fkt61(b) + summe)/3;
    return integralwert
#   endfunction

def main():
    fwert = fassregel_gb0(0,1,30)

    print('Integralwert:',fwert)

if __name__ == '__main__':
    main()

