#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math

# Programm 7.5 zur Gauss-Seidel-Iteration (gaussseidelit_gb.m)
# input:  Diagonalen l,d,u der Koeffizientenmatrix a, l(1) und u(n) sind dummy-Werte
#         rechte Seite b
# output: Loesung x
# Aufruf: [x] = gaussseidelit_gb1(l,d,u,b)

def gaussseidelit_gb0(l,d,u,b):
    n = len(d);
    xdiff = 1.0; xnorm = 1.0
    it = 0
    x = np.ones(n)
    xalt = np.ones(n)
    while (xdiff/xnorm > 1.0e-9):
        xalt[:] = x[:]
        x[0] = (b[0] - u[0]*x[1])/d[0]
        for k in range(1,n-1):
            x[k] = (b[k] - l[k]*x[k-1] - u[k]*x[k+1])/d[k]
#       endfor
        x[n-1] = (b[n-1] - l[n-1]*x[n-2])/d[n-1]
        xdiff = np.linalg.norm(x - xalt)
        xnorm = np.linalg.norm(xalt)
        print("xdiff=",xdiff)    
        if (xnorm == 0):
            xnorm = 1.0
#       endif
        it = it + 1
#   endwhile
    return (x,it)
# endfunction

def main():
    l = np.ones(5)
    d = 4*np.ones(5)
    u = np.ones(5)
    b = np.ones(5)

    x,it = gaussseidelit_gb0(l,d,u,b)

    print('Loesung:',x)
    print('Iterationszahl:',it)

if __name__ == '__main__':
    main()

