#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math

# Nutzer-Funktion
# exakter Wert von \int_0^1 4/(x*x+1) dx ist pi
def fkt61(x):
    y = 4/(x*x+1)
    return y
#   endfunction

# Programm 6.2
# Gauss-Tschebyscheff-Quadratur
# \int_a^b fkt62(x) dx 
# input:  Intervallgrenzen a,b, Stuetzstellenzahl n
# output: Wert des Integrals
# benutzte Funktion: fkt62
# Aufruf: [integralwert] = gausstscheby_gb0(a,b,n)

def gausstscheby_gb0(a,b,n):
    integral = 0
    x = np.ones(n); t = np.ones(n)
    for j in range(0,n):
        x[j] = math.cos(((2*(j+1)-1)*math.pi)/(2*n))
        t[j] = x[j]*(b-a)/2+(a+b)/2
        integral = integral + fkt61(t[j])*math.sqrt(1-x[j]*x[j])
#   endfor
    integralwert = integral*math.pi*(b-a)/(2*n)
    return integralwert
#   endfunction

def main():
    fwert = gausstscheby_gb0(0,1,30)

    print('Integralwert:',fwert)

if __name__ == '__main__':
    main()

