#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math

# Programm 7.4 zur Jacobi-Iteration (jacobiit_gb.m)
# input:  Diagonalen l,d,u der Koeffizientenmatrix a, l(1) und u(n) sind dummy-Werte
#         rechte Seite b
# output: Loesung x
# Aufruf: [x] = jacobiit_gb0(l,d,u,b)

def jacobiit_gb1(l,d,u,b):
    n = len(d);
    xdiff = 1.0; xnorm = 1.0; it = 0
    x = np.ones(n)
    xneu = np.ones(n)
    while (xdiff/xnorm > 0.0000000001):
        xneu[0] = (b[0] - u[0]*x[1])/d[0]
        xneu[1:n-1] = (b[1:n-1] - l[1:n-1]*x[0:n-2] - u[1:n-1]*x[2:n])/d[1:n-1]
        xneu[n-1] = (b[n-1] - l[n-1]*x[n-2])/d[n-1]
        xdiff = np.linalg.norm(xneu - x)
        x[:] = xneu[:]
        xnorm = np.linalg.norm(x)
        print("xdiff=",xdiff)
        if (xnorm == 0):
            xnorm = 1.0
#       endif
        it = it +1
#   endwhile
    return (x,it)
# endfunction

def main():
    l = np.ones(5)
    d = 4*np.ones(5)
    u = np.ones(5)
    b = np.ones(5)

    x,it = jacobiit_gb1(l,d,u,b)

    print('Loesung:',x)
    print('Iterationszahl:',it)

if __name__ == '__main__':
    main()

