#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math

# Programm 3.1 zur QR-Zerlegung einer Matrix c0 = q*r
# Erzeugung der wesentlichen Informationen fuer 
# die orthogonale Matrix Q und der oberen Dreiecksmatrix R
# input:  Matrix c=(c(ij)) vom Typ m x p gegeben (m >= p)
# output: Matrix c mit den wesentlichen Informationen
#         der orthogonalen Matrix q und der oberen Dreiecksmatrix r,
#         Erzeugung des inputs fuer das Programm bestapprqr_gb.m,
# Aufruf: [c,t] = qr_gb0(c);

def qr_gb0(c0):
    m = len(c0)
    p = len(c0[0])
    c = np.zeros((m,p))
    t = np.zeros(p)
    c[:,:] = c0[:,:]
    for l in range(0,p): # mslice[1:p]:
        gamma = np.dot(c[l:m,l],c[l:m,l])
        gamma = math.sqrt(gamma)
        if (c[l,l] < 0):
            gamma = -gamma
#       endif
        peta = math.sqrt(2*gamma*(gamma + c[l,l]))
        t[l] = -gamma #        t(l).lvalue = -gamma
        c[l,l] = (c[l,l] + gamma)/peta #        c(l, l).lvalue = (c(l, l) + gamma) / peta
        c[l+1:m,l] = c[l+1:m,l]/peta
        for j in range(l+1,p): # mslice[l + 1:p]:
            g = np.dot(c[l:m,l],c[l:m,j])
            g = g + g
            c[l:m,j] = c[l:m,j] - g*c[l:m,l]
#       endfor
#   endfor
    return (c, t)
#   endfunction
