#!/usr/bin/python
# -*-coding: utf-8-*-

import math
import numpy as np

# Programm 4.2 Ein Schritt H^k,P^k --> H^{k+1},P^{k+1} zum QR-Verfahren 
# sukzessive Berechnung der Eigenwerte einer (n x n)-Hessenberg-Matrix H
# H^k,P^k Shift kappa und delta (kleinste Zahl >0) sind vorgegeben
# input:  h0=H^k, p0=P^k (P^0 = eye), Shift kappa und delta (kleinste Zahl >0)
# output: h=H^{k+1}, p=P^{k+1}
# Aufruf: [h,p] = qriteration_gb(h0,p0,kappa,delta);

def qriteration_gb(h0,p0,kappa,delta):
    n = len(h0)
    h = np.zeros((n,n)) ; p = np.zeros((n,n))
    for i in range(n):
        for j in range(n):
            h[i,j] = h0[i,j]
            p[i,j] = p0[i,j]
    ss = 1; cs = 1
    n = len(h)
    h[0,0] = h[0,0] - kappa
    for i in range(0,n): #  i=1:n
        if (i < n-1):   # i < n
            if (abs(h[i,i]) < delta*abs(h[i+1,i])):
                w= abs(h[i+1,i])
                c=0
                s = np.sign(h[i+1,i])
            else:
                w=math.sqrt(h[i,i]*h[i,i] + h[i+1,i]*h[i+1,i])
                c = h[i,i]/w;
                s = -h[i+1,i]/w;
#           endif
            h[i,i]=w;
            h[i+1,i]=0;
            h[i+1,i+1]=h[i+1,i+1]-kappa;
            for j in range(i+1,n): # j=i+1:n
                g=c*h[i,j]-s*h[i+1,j]
                h[i+1,j]=s*h[i,j]+c*h[i+1,j]
                h[i,j]=g
#           endfor
#       endif
        if (i > 0):
            for j in range(0,i+1): # j=1:i
                g=cs*h[j,i-1]-ss*h[j,i]
                h[j,i]=ss*h[j,i-1]+cs*h[j,i]
                h[j,i-1]=g
#           endfor
            h[i-1,i-1]=h[i-1,i-1]+kappa
#       endif
        if (i < n-1):
            for j in range(0,n): #  j=1:n
                g=c*p[j,i]-s*p[j,i+1]
                p[j,i+1]=s*p[j,i]+c*p[j,i+1]
                p[j,i]=g
#           endfor
#       endif[[0 for col in range(col)] for row in range(row)]
        cs = c; ss = s
#   endfor
    h[n-1,n-1]=h[n-1,n-1]+kappa
    return h,p
# endfunction
