#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math
import cmath
from scipy.fft import fft

# Programm 5.6 reelle Fourier-Analyse
# input:  k=2n diskrete Funktionswerte einer periodischen Funktion
#         y_1, y_2,...,y_k
# output: reelle Fourierkoeffizienten a_0,a_1,...,a_n, b_0,b_1,...,b_n
#         b_0 = b_n =0 dummy-Werte
# Aufruf: [a,b] = rfft_gb(y);

def rfft_gb(y):
    k = len(y)
    if (2*math.floor(k/2) != k):
        print('ungerade Zahl von Funktionswerten')
        return
#   endif
    n = int(k/2)
    I = cmath.sqrt(-1)
    z = np.zeros(n, dtype=complex)
    a = np.zeros(n+1); b = np.zeros(n+1)
    c = np.zeros(n+1, dtype=complex)
    ab = np.zeros(n+1, dtype=complex)
    for k in range(0,n):
        z[k]=y[2*k]+y[2*k+1]*I
#   endfor
# Bestimmung der komplexen Fourierkoeffizienten
    cf = fft(z)
    for k in range(n):
        c[k] = cf[k]
#   endfor
    c[n] = c[0]
# Berechnung der reellen Fourierkoeffizienten
    for k in range(0,n+1):
        ck = c[k]
        cck = np.conjugate(c[n-k])
        ab[k] = 0.5*(ck + cck) - 0.5*I*(ck - cck)*cmath.exp(-k*I*math.pi/n)
#   endfor
    for k in range(0,n+1):
        a[k] = np.real(ab[k])/n
        if (k == 0 or k == n):
            b[k] = 0
#       endif
        b[k]=-np.imag(ab[k])/n
#   endfor
    return (a,b)
# endfunction

