#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np

# Programm 8.3a
# zur Bereitstellung 
# der rechten Differentialgleichungsseite g(x,y)
def g(j,x,y1,y2,y3):
    if (j == 1):
        z = -0.1*y1+100*y2*y3
    if (j == 2):
        z = 0.1*y1-100*y2*y3-500*y2*y2
    if (j == 3):
         z = 500*y2*y2-0.5*y3
    return z
# endfunction

# Programm 8.3 (ruku4sys_gb.m)
# zur Loesung eines Systems von 3 DGL 1. Ordnung y_j'=g_j(x,y), y_(x_0)=y_0j
# klassisches Runge-Kutta-Verfahren 4. Ordnung
# input:  Schrittweite h, Intervallgrenzen x0,x1, Anfangswerte y0j=y_j(x0),
# output: Loesung y1(x),y2(x),y3(x) an den Punkten x
# benutztes Programm: Nutzerfunktion g (rechte Seite der Dgl.)
# Aufruf: [y1,y2,y3,x] = ruku4sys_gb(x0,x1,y01,y02,y03,h);

def ruku4sys_gb(x0,x1,y01,y02,y03,h):
    n = int((x1 - x0)/h)
    x = np.zeros(n+1)
    y1 = np.zeros(n+1); y2 = np.zeros(n+1); y3 = np.zeros(n+1)
    yn1 = y01; y1[0] = y01
    yn2 = y02; y2[0] = y02
    yn3 = y03; y3[0] = y03
    xn = x0; x[0] = x0
    for k in range(0,n):
        k11 = g(1,xn,yn1,yn2,yn3)
        k12 = g(2,xn,yn1,yn2,yn3)
        k13 = g(3,xn,yn1,yn2,yn3)
        k21 = g(1,xn+0.5*h,yn1+0.5*h*k11,yn2+0.5*h*k12,yn3+0.5*h*k13)
        k22 = g(2,xn+0.5*h,yn1+0.5*h*k11,yn2+0.5*h*k12,yn3+0.5*h*k13)
        k23 = g(3,xn+0.5*h,yn1+0.5*h*k11,yn2+0.5*h*k12,yn3+0.5*h*k13)
        k31 = g(1,xn+0.5*h,yn1+0.5*h*k21,yn2+0.5*h*k22,yn3+0.5*h*k23)
        k32 = g(2,xn+0.5*h,yn1+0.5*h*k21,yn2+0.5*h*k22,yn3+0.5*h*k23)
        k33 = g(3,xn+0.5*h,yn1+0.5*h*k21,yn2+0.5*h*k22,yn3+0.5*h*k23)
        k41 = g(1,xn+h,yn1+h*k31,yn2+h*k32,yn3+h*k33)
        k42 = g(2,xn+h,yn1+h*k31,yn2+h*k32,yn3+h*k33)
        k43 = g(3,xn+h,yn1+h*k31,yn2+h*k32,yn3+h*k33)
        yn1 = yn1 + h*(k11+2.0*k21+2.0*k31+k41)/6.0
        yn2 = yn2 + h*(k12+2.0*k22+2.0*k32+k42)/6.0
        yn3 = yn3 + h*(k13+2.0*k23+2.0*k33+k43)/6.0
        xn = xn+h; x[k+1]=xn; y1[k+1]=yn1; y2[k+1]=yn2; y3[k+1]=yn3
#   endfor
    return (y1,y2,y3,x)
# endfunction

def main():
    x0 = 0
    x1 = 10
    y01 = 4
    y02 = 2
    y03 = 0.5 
    h = 0.0002
    y1,y2,y3,x = ruku4sys_gb(x0,x1,y01,y02,y03,h)

    import matplotlib.pyplot as plt
    plt.plot(x,y1,color="blue",linewidth = 1, linestyle="-")
    plt.plot(x,y2,color="blue",linewidth = 1, linestyle="-")
    plt.plot(x,y3,color="blue",linewidth = 1, linestyle="-")

if __name__ == '__main__':
    main()

