#!/usr/bin/python
# -*-coding: utf-8-*-

from numpy import linalg as la
import numpy as np
import math

# Programm 9.2b
# Aufbau der Jacobi-Matrix
def jacobirwp(y,y0,n,h,lambd,sigma):
    jm = np.zeros((n-1,n-1)) # jm = [[0 for j in range(n-1)] for k in range(n-1)]
    jm[0,0] = lambd*3/math.pow(h,2)+ 4*sigma*math.pow(y[0],3)
    for k in range(1,n-2):
        jm[k,k] = lambd*2/math.pow(h,2) + 4*sigma*math.pow(y[k],3)
#   endfor
    jm[n-2,n-2]=lambd/math.pow(h,2) + 4*sigma*math.pow(y[n-2],3)
    for k in range(0,n-2):
        jm[k,k+1]=-lambd/math.pow(h,2)
        jm[k+1,k]=-lambd/math.pow(h,2)
#   endfor
    return jm
# endfunction

# Programm 9.2a
# Aufbau der Gleichungen
def gleichungrwp(y,y0,n,h,lambd,sigma,q):
    grwp = np.zeros(n-1)
    grwp[0]=lambd*(3*y[0]-y[1]-2*y0)/math.pow(h,2) + sigma*math.pow(y[0],4)
    for k in range(1,n-2):
        grwp[k]=lambd*(2*y[k]-y[k+1]-y[k-1])/math.pow(h,2) + sigma*math.pow(y[k],4)
#    grwp[1:n-2]=lambd*(2*y[1:n-2]-y[2:n-1]-y[0:n-3])/math.pow(h,2) + sigma*math.pow(y[1:n-2],4)   falsch
#   endfor
    grwp[n-2]=lambd*(y[n-2]-y[n-3])/math.pow(h,2) + q/h + sigma*math.pow(y[n-2],4)
    return grwp
# endfunction

# Programm 9.2 zur Loesung eines nichtlin. Randwertproblems (rwp2nl_gb.m) 
# -lambda*y'' + sigmaa*y^4 = 0; y(a)=y0, -lambda*y'(b)=q
# input:  lambda, sigmaa, Intervallgrenzen a,b, Randwerte y0, q, Stuetzst.zahl n
# output: Loesung y(x) an den Stellen x
# Benutzung der Programme jacobirwp, gleichungrwp
# Aufruf: [y,x] = rwp2nl_gb0(lambda,sigmaa,a,b,y0,q,n);

def rwp2nl_gb1(lambd,sigma,a,b,y0,q,n):
    h = (b-a)/n
    sigma0 = 0
    x = np.zeros(n-1)
    x = np.linspace(a+h/2,b-3*h/2,n-1)
#    for k in range(n-1):
#        x[k] = a + (k+1)*h - h/2
#   endfor
    y = np.zeros(n-1); yn = np.zeros(n-1); z = np.zeros(n-1)
# Aufbau der Jacobi-Matrix
    jm = jacobirwp(y,y0,n,h,lambd,sigma0)
# Aufbau der Gleichungen
    grwp = gleichungrwp(y,y0,n,h,lambd,sigma0,q)
# Berechnung der Startiteration = ein Newtonschritt
# fuer das benachbarte lineare Problem
    y = -np.linalg.solve(jm,grwp)
    defekt = 1
    it = 0
# Newtoniteration
    while (defekt > 1.0e-06 and it < 10):
        jm = jacobirwp(y,y0,n,h,lambd,sigma)
        grwp = gleichungrwp(y,y0,n,h,lambd,sigma,q)
        z = -np.linalg.solve(jm,grwp)
        yn = y + z; defekt = la.norm(z)
        it = it + 1
        y = yn
#   endwhile
    return (y,x)
# endfunction

def main():
    lambd=1
    sigma=5.0e-06
    a=0
    b=1
    y0=150
    q=20
    n=20
    y,x = rwp2nl_gb1(lambd,sigma,a,b,y0,q,n)

    import matplotlib.pyplot as plt
    plt.plot(x,y,color="blue",linewidth = 1, linestyle="-")

if __name__ == '__main__':
    main()

