#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math

# Programm 7.6 zum SOR-Verfahren (sorit_gb.m)
# input:  Diagonalen l,d,u der Koeffizientenmatrix a, l(1) und u(n) sind dummy-Werte
#         rechte Seite b,
#         Relaxationsfaktor omega \in ]0,2[
# output: Loesung x
# Aufruf: [x] = sorit_gb0(l,d,u,b,omega);

def sorit_gb0(l,d,u,b,omega):
    n = len(d);
    xdiff = 1.0; xnorm = 1.0; it = 0
    x = np.zeros(n); xalt = np.zeros(n)
#    x = [0 for k in range(n)]; xalt = [0 for k in range(n)]
    while (xdiff/xnorm > 1.0e-9):
        xalt[:] = x[:]
#        for k in range(n):
#            xalt[k] = x[k]
#       endfor
        x[0] = (b[0] - u[0]*x[1])/d[0]
#        for k in range(1,n-1):
#            x[k] = (b[k] - l[k]*x[k-1] - u[k]*x[k+1])/d[k]
        x[1:n-1] = (b[1:n-1] - l[1:n-1]*x[0:n-2] - u[1:n-1]*x[2:n])/d[1:n-1]
#       endfor
        x[n-1] = (b[n-1] - l[n-1]*x[n-2])/d[n-1]
        x = omega*x + (1-omega)*xalt
#        xdiff = 0
#        xnorm = 0
#        for k in range(n):
#            x[k] = omega*x[k]+(1.0-omega)*xalt[k]
#            xdiff = xdiff + math.pow((x[k]-xalt[k]),2)
#            xnorm = xnorm + math.pow(xalt[k],2)
#       endfor
        xdiff = np.linalg.norm(x-xalt)
        xnorm = np.linalg.norm(xalt)
        print("xdiff=",xdiff)    
        if (xnorm == 0):
            xnorm = 1.0
#       endif
        it = it +1
#   endwhile
    return (x,it)
# endfunction

def main():
    l = np.ones(5)
    d = 4*np.ones(5)
    u = np.ones(5)
    b = np.ones(5)
    omega = 1.0

    x,it = sorit_gb0(l,d,u,b,omega)

    print('Loesung:',x)
    print('Iterationszahl:',it)

if __name__ == '__main__':
    main()

