#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math
import matplotlib.pyplot as plt


# Programm 10.1: strong_wiener_gb.m , starke Approximation von W 
#
# Wiener-Prozess ueber [0,1] mit dt = 2^(-10))
# starke Approximation auf Gitter mit Dt = R*dt

np.random.seed(50) # random seeding
Wzero = 0 ; T = 1 ; N = int(math.pow(2,10)) ; dt = 1/N
dW = np.zeros(N); W = np.zeros(N)  # Pre-Allokierung
dW = np.dot(math.sqrt(dt),np.random.randn(N))  # Inkremente
W = np.cumsum(dW)  # Wiener-Prozess
R = 4; Dt = R*dt
tw = np.zeros(N+1); tw[0] = 0.0 
waw = np.zeros(N+1); waw[0] = Wzero
for j in range(1,N+1):
    tw[j] = dt + j*dt
    waw[j] = W[j-1]
# endfor
plt.plot(tw,waw,'g-')
##   plot([0:dt:T],[Wzero,W],'g-'), hold on
L = int(N/R)  # L EM steps of size Dt = R*dt
Xtrue = np.zeros(N)
for i in range(N):
    Xtrue[i] = W[i]
# endfor
WA = np.zeros(L) # Pre-Allokierung 
Wtemp = Wzero ;
for j in range(L): #   for j = 1:L
    Winc =  sum(dW[R*j:R*(j+1)]) 
    Wtemp = Wtemp + Winc 
    WA[j] = Wtemp 
# endfor
wa = np.zeros(L+1)
t = np.zeros(L+1); t[0] = 0.0; wa[0] = Wzero
for j in range(1,L+1):
    t[j] = Dt + j*Dt
    wa[j] = WA[j-1]
# endfor
##  plot([0:Dt:T],[Wzero,WA],'r--*'), hold off
plt.plot(t, wa, 'r-')
##  xlabel('t','FontSize',16)
##  ylabel('W','FontSize',16)
plt.xlabel('t')
plt.ylabel('W')
plt.title('Approx. eines Wiener-Prozesses')
plt.legend(["Wiener-Prozess", "Starke Approxiamtion"], loc ="upper right")
plt.show()
emerr = abs(WA[L-1] - Xtrue[N-1])
# Programmende
